package fbots;

import robocode.*;
import robocode.util.*;

public class Follow extends AdvancedRobot {
	
	// hier speichern wir das aktuelle Scanergebnis
	private ScannedRobotEvent actualScanData = null;
	
	// minimale und maximale Distanz zum Gegner
	private final int DIST_MIN = 200;
	private final int DIST_MAX = 250;
	
	// beim ersten Scan muessen wir 360 scannen da wir nicht wissen
	// wo der Gegner ist
	double radarAngle = 360;
	boolean scanned = false;	

	public void run(){
		
		
		// erstes Scannen des Spielfeldes
		setTurnRadarRight(radarAngle);
		execute();
		
		while(true){
			
			// Radar um berechneten Wert drehen, falls Gegner danach 
			// nicht gefunden wurde kompletter Rescan des Feldes
			setTurnRadarRight(radarAngle);
			if(scanned == false){
				radarAngle = 360;
				execute();
				continue;
			}
			
			// Bin ich naeher am Gegner als DIST_MIN oder weiter weg als DIST_MAX?
			double dist = actualScanData.getDistance();
			
			// falls zu nah: weg vom Gegner!
			if(dist < DIST_MIN){
				
				setTurnRight(actualScanData.getBearing()); //drehen
				waitFor(new TurnCompleteCondition(this)); //warten
				setBack((DIST_MIN - dist) + (DIST_MAX+DIST_MIN)/2); //fahren
				
			// falls zu weit: hin zum Gegner!
			} else if(dist > DIST_MAX) {
				
				setTurnRight(actualScanData.getBearing()); //drehen
				waitFor(new TurnCompleteCondition(this)); //warten
				setAhead((dist - DIST_MAX) + (DIST_MAX+DIST_MIN)/2); //fahren
				
			}
			
			execute();
			
			// Gegner ist aus dem Radar raus
			scanned = false;
		}
		
	}
	
	public void onScannedRobot(ScannedRobotEvent e){
		
		// Gegner gefunden		
		scanned = true;
		
		// Event speichern
		actualScanData = e;
		
		// Berechnung des neuen Winkels fuers Radar		
		radarAngle = Utils.normalRelativeAngleDegrees(e.getBearing() + (getHeading() - getRadarHeading()));
		
		
	}
}