package fbots;

import robocode.*;
import robocode.util.*;
import java.util.Random;

public class Pazifista extends AdvancedRobot {
	
	// hier speichern wir das letzte und das aktuelle Scanergebnis
	private ScannedRobotEvent lastScanData = null;
	private ScannedRobotEvent actualScanData = null;
	
	// beim ersten Scan muessen wir 360 scannen da wir nicht wissen
	// wo der Gegner ist
	double radarAngle = 360;
	boolean scanned = false;	

	public void run(){
		
		
		// erstes Scannen des Spielfeldes
		setTurnRadarRight(radarAngle);
		execute();
		
		while(true){
			
			// Radar um berechneten Wert drehen,
			// falls Gegner danach nicht gefunden wurde
			// kompletter Rescan des Feldes
			setTurnRadarRight(radarAngle);
			if(scanned == false){
				radarAngle = 360;
				execute();
				continue;
			}
			
			execute();
			
			// Gegner ist aus dem Radar raus
			scanned = false;
		}
		
	}
	
	public void onScannedRobot(ScannedRobotEvent e){
		
		// Gegner gefunden		
		scanned = true;
		
		// falls bisher noch keine Daten gespeicher wurden
		// speichere Daten und fertig...
		if(actualScanData == null){
			actualScanData = e;
			return;
		}
		
		// ... ansonsten "verschiebe" daten		
		lastScanData = actualScanData;		
		actualScanData = e;
		
		// Hat der Gegner energie verloren?
		// Falls ja: AUSWEICHEN!
		if(lastScanData.getEnergy() > actualScanData.getEnergy()){
			evadeShot();
		}

		// Berechnung des neuen Winkels fuers Radar		
		radarAngle = Utils.normalRelativeAngleDegrees(e.getBearing() + (getHeading() - getRadarHeading()));
		
		
	}
	
	/** 
	 * Wir weichen aus. Entweder nach vorne.. oder nach hinten
	 */
	public void evadeShot(){
		
		// TODO: Hier vielleicht noch orthogonal zum Schuss ausrichten?
		
		Random r = new Random();
		if(r.nextInt(2) == 1){
			setAhead(50);
		} else {
			setBack(50);
		}
	}
}