package fbots;

import robocode.*;
import robocode.util.*;
import java.awt.*;

public class Propart extends AdvancedRobot {
	
	// hier speichern wir das aktuelle Scanergebnis
	private ScannedRobotEvent actualScanData = null;
	
	// beim ersten Scan muessen wir 360 scannen da wir nicht wissen
	// wo der Gegner ist
	double radarAngle = 360;
	boolean scanned = false;	

	public void run(){
		
		
		// erstes Scannen des Spielfeldes
		setTurnRadarRight(radarAngle);
		execute();
		
		while(true){
			
			// Radar um berechneten Wert drehen, falls Gegner danach 
			// nicht gefunden wurde kompletter Rescan des Feldes
			setTurnRadarRight(radarAngle);
			if(scanned == false){
				radarAngle = 360;
				execute();
				continue;
			}
			
			execute();
			
			// Gegner ist aus dem Radar raus
			scanned = false;
		}
		
	}
	
	public void onScannedRobot(ScannedRobotEvent e){
		
		// Gegner gefunden		
		scanned = true;
		
		// Event speichern
		actualScanData = e;
		
		// Distanz zum Gegner im Debugfenster anzeigen:
		// unschoen, da Fenster zugespamt wird
		System.out.println(e.getDistance());
		// kein gespamme, dafuer aber nur ein Wert
		setDebugProperty("Entfernung zum Gegner:", ""+e.getDistance());
		
		// Berechnung des neuen Winkels fuers Radar		
		radarAngle = Utils.normalRelativeAngleDegrees(e.getBearing() + (getHeading() - getRadarHeading()));
	}
	
	public void onPaint(Graphics2D g){
		
		// absoluter Winkel vom Gegner
		double alpha = getHeading() + actualScanData.getBearing();
		if(alpha < 0) alpha += 360;
		
		double hypotenuse = actualScanData.getDistance();
		double x = getX() + Math.sin(Math.toRadians(alpha)) * hypotenuse;
		double y = getY() + Math.cos(Math.toRadians(alpha)) * hypotenuse;
		
		setDebugProperty("Position des Gegners:", "x: "+x+" y: "+y);
		
		// Farbe auf durchsichtiges Rot setzen
        g.setColor(new Color(0xFF, 0, 0, 70));
        
        // Rechteck auf Gegner malen
        g.fillRect((int)x-25, (int)y-25, 50, 50);
		
	}
}